//////////////////////////////////////////////////////////////////////
// sangoma_port.h: interface for the sangoma_port class.
//
// Author	:	David Rokhvarg	<davidr@sangoma.com>
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRIVER_CONFIGURATOR_H__115A6EC1_518C_45E9_AA55_148A8D999B61__INCLUDED_)
#define AFX_DRIVER_CONFIGURATOR_H__115A6EC1_518C_45E9_AA55_148A8D999B61__INCLUDED_

#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include <conio.h>
#include <stddef.h>		//for offsetof()
#include <stdlib.h>

#if !defined(__WINDOWS__)
 #define __WINDOWS__
#endif

#include <wanpipe_defines.h>	//for 'wan_udp_hdr_t'
#include <wanpipe_version.h>	//for DRIVER_VERSION structure
#include <sang_status_defines.h>//return codes
#include <sang_api.h>			//for IOCTL codes
#include <sdla_remora.h>		//Analog card
#include <wanpipe_cfg.h>		//for RBS commands, Media Types (WAN_MEDIA_NONE...)

#include <bit_win.h>
#include <sdlasfm.h>
#include <sdlapci.h>

#define MAX_CARDS			16
#define MAX_PORTS_PER_CARD	8

class sangoma_port
{
public:
	int get_hardware_info(hardware_info_t *hardware_info);
	int stop_or_start_port(int command);

	HANDLE open_api_device(char *api_device_name);
	int init(unsigned int wanpipe_number);

	int get_port_statistics(port_stats_t *port_stats);
	int flush_port_statistics();

	sangoma_port();
	virtual ~sangoma_port();

	int scan_for_sangoma_cards(wanpipe_instance_info_t *wanpipe_info_array, int card_model);

protected:
	unsigned int wp_number;
	char wanpipe_name_str[WAN_DRVNAME_SZ*2];
	HANDLE wp_handle;

	int PortManagementIoctl(port_management_struct_t *port_management);
	int PortManagementCmd(int cmd, void *data, int data_size);


	int push_a_card_into_wanpipe_info_array(wanpipe_instance_info_t *wanpipe_info_array,
										hardware_info_t *new_hw_info);
};

#endif // !defined(AFX_DRIVER_CONFIGURATOR_H__115A6EC1_518C_45E9_AA55_148A8D999B61__INCLUDED_)

